<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN" [
<!ENTITY % html "IGNORE">
<![%html;[
<!ENTITY % print "IGNORE">
<!ENTITY docbook.dsl SYSTEM "/usr/share/sgml/docbook/dsssl-stylesheets/html/docbook.dsl" CDATA dsssl>
]]>
<!ENTITY % print "INCLUDE">
<![%print;[
<!ENTITY docbook.dsl SYSTEM "/usr/share/sgml/docbook/dsssl-stylesheets/print/docbook.dsl" CDATA dsssl>
]]>
]>

<style-sheet>


<style-specification id="print" use="docbook">
<style-specification-body> 

;changes to support C++ member functions and Docbook customizations
(element funcprototype
 (let* ((paramdefs (select-elements (children (current-node))
		    (normalize "paramdef")))
	(funcdef (node-list-first (children (current-node))))
	(dispatch-val (attribute-string (normalize "dispatch") funcdef)))
  (make sequence
   (make paragraph
    font-family-name: %mono-font-family%
    (if (or (string=? dispatch-val (normalize "virtual"))
	 (string=? dispatch-val (normalize "abstract")))
     (literal "virtual ")
     (empty-sosofo))
    (process-children)
    (if (string=? (attribute-string (normalize "const") funcdef)
	 (normalize "const"))
     (literal " const")
     (empty-sosofo))
    (if (string=? dispatch-val (normalize "abstract"))
     (literal " = 0")
     (empty-sosofo))
    (literal ";"))
   (if (equal? %funcsynopsis-style% 'kr)
    (with-mode kr-funcsynopsis-mode
     (process-node-list paramdefs))
    (empty-sosofo)))))

    (element void
     (if (equal? %funcsynopsis-style% 'ansi)
      (literal "(void)")
      (literal "()")))

    (element varargs (literal "(...)"))

    (element paramdef
     (let ((param (select-elements (children (current-node)) (normalize
							      "parameter"))))
      (make sequence
       (if (equal? (child-number (current-node)) 1)
	(literal "(")
	(empty-sosofo))
       (if (equal? %funcsynopsis-style% 'ansi)
	(process-children)
	(process-node-list param))
       (if (equal? (gi (ifollow (current-node))) (normalize "paramdef"))
	(literal ", ")
	(literal ")")))))

;; ====================
;; customize the print stylesheet
;; ====================

;; make funcsynopsis look pretty
(define %funcsynopsis-decoration%
  ;; Decorate elements of a FuncSynopsis?
  #t)

;; fix some of the document attributes
(define %left-margin%
   10mm)

(define %right-margin%
   15mm)

(define %top-margin%
   10mm)

(define %bottom-margin%
   10mm)

(define %paper-type%
   "A4")

;; fix some stuff about tables
;; there should be way to set the tables width


;; fix some stuff about graphics (figures)
;; there should be way to get graphics in the right width
(define %graphic-default-extension% "eps")



;; misc stuff from the original dsl driver
(declare-characteristic preserve-sdata?
          "UNREGISTERED::James Clark//Characteristic::preserve-sdata?"
          #f)
(define %two-side% 
  #t)
(define %section-autolabel% 
  #t)
(define %generate-part-toc% #t)


</style-specification-body>
</style-specification>

<!--
;; ====================
;; customize the html stylesheet
;; ====================
-->
<style-specification id="html" use="docbook">
<style-specification-body> 

; make sure the software-description.css stylesheet is used
(define %stylesheet% 
        "./developer-guide.css")

;; this is necessary because right now jadetex does not understand
;; symbolic entities, whereas things work well with numeric entities.
(declare-characteristic preserve-sdata?
          "UNREGISTERED::James Clark//Characteristic::preserve-sdata?"
          #f)

;; put the legal notice in a separate file
(define %generate-legalnotice-link%
  #t)

;; use graphics in admonitions, and have their path be "stylesheet-images"
;; NO: they do not yet look very good
(define %admon-graphics-path%
  "./stylesheet-images/")
(define %admon-graphics%
  #f)

;; make funcsynopsis look pretty
(define %funcsynopsis-decoration%
  ;; Decorate elements of a FuncSynopsis?
  #t)

(define %html-ext% ".html")

(define %body-attr%
  '())

(define %generate-article-toc% 
  #t)

(define %generate-part-toc% #t)

(define %shade-verbatim%
  #t)

(define %use-id-as-filename%
  ;; Use ID attributes as name for component HTML files?
  #t)

(define %graphic-default-extension% "png")


</style-specification-body>
</style-specification>

<external-specification id="docbook" document="docbook.dsl">

</style-sheet>
