// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "characters.h"

namespace Common {

    char
    upper(char c) {
	if(is_lower(c)) {
	    return c + 'A' - 'a';
	}
	else {
	    return c;
	}
    }

    char
    lower(char c) {
	if(is_upper(c)) {
	    return c + 'a' - 'A';
	}
	else {
	    return c;
	}
    }

    //
    //
    //

    bool
    is_space(char c) {
	return c == ' ' || c == '\r' || c == '\n' || c == '\t';
    }

    bool
    is_upper(char c) {
	return c >= 'A' && c <= 'Z';
    }

    bool
    is_lower(char c) {
	return c >= 'a' && c <= 'z';
    }

    bool
    is_digit(char c) {
	return c >= '0' && c <= '9';
    }

    bool
    is_alpha(char c) {
	return is_lower(c) || is_upper(c);
    }

    bool
    is_alphanumeric(char c) {
	return is_alpha(c) || is_digit(c);
    }

} // namespace Common
