// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "command_set_mode.h"

#include "foundation/macros.h"

#include "mode.h"
#include "editor.h"

namespace Diagram {

    CommandSetMode::CommandSetMode(Mode * mode, const string & name) : Command(name), mMode(mode) {
        ASSERT(mMode);
        mMode->ref();
    }

    CommandSetMode::~CommandSetMode() {
        mMode->unref();
    }

    void
    CommandSetMode::execute() {
	Editor * editor = Editor::current();

        if(editor) {
            editor->push(mMode);
        }
        else {
            ERROR("No current editor");
        }
    }

    void
    CommandSetMode::unexecute() {
	// makes no sense

	ERROR("Can't unexecute this command");
    }

} // name Diagram
