// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_FIG_EDGE_TEXT_H
#define DIAGRAM_FIG_EDGE_TEXT_H

#include "fig_text.h"

namespace Diagram {

    class FigEdge;

    class FigEdgeText : public FigText {
    public:
	explicit FigEdgeText(FigEdge * edge);
	~FigEdgeText();

	void compute_position();
	void compute_relationship();

	FigEdge * get_edge() { return mEdge; }

	double get_fraction() const { return mFraction; }
	double get_distance() const { return mDistance; }

	void set_fraction(double fraction) { set_all(fraction, get_distance()); }
	void set_distance(double distance) { set_all(get_fraction(), distance); }
	void set_all(double fraction, double distance);

    private:
	FigEdge * mEdge;

	double mFraction;		// fraction of the way along the edge's poly line
	double mDistance;		// perpendicular distance from the edge's poly line
    };

} // namespace Diagram

#endif // DIAGRAM_FIG_EDGE_TEXT_H
