// This code is a modified port of GEF (Graphical Editing Framework)
// http://gef.tigris.org/
// GEF is copyrighted by the Regents of the University of California

// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_FIG_GROUP_H
#define DIAGRAM_FIG_GROUP_H

#include "fig.h"

#include <list>
using namespace std;

namespace Diagram {

    class FigGroup : public Fig {
    public:
	FigGroup(Object * owner);
	~FigGroup();

	void paint(Drawing::Drawable * drawable) const;

	void relocate(const Drawing::Point & position);
	void resize(const Drawing::Vector & size);

	bool hit(const Drawing::Rectangle & rect) const;

	void set_filled(bool filled);
	void set_line_color(const string & line_color);
	void set_fill_color(const string & fill_color);
	void set_line_style(Drawing::LineStyle line_style);
	void set_layer(Layer * layer);

#if 0
	Fig * hit_fig(const Rectangle & rect);
#endif

    protected:
	// does nothing by default, but subclasses might want
	// to organise their children when the bounds change
	virtual void layout() = 0;

	list<Fig *> mChildren;

    private:
    };

} // namespace Diagram

#endif // DIAGRAM_FIG_GROUP_H
