// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DIAGRAM_MODE_CREATE_FIG_POLY_EDGE_H
#define DIAGRAM_MODE_CREATE_FIG_POLY_EDGE_H

#include "mode_create_fig_poly.h"

namespace Diagram {

    class ModeCreateFigPolyEdge : public ModeCreateFigPoly {
    public:
	ModeCreateFigPolyEdge();
	~ModeCreateFigPolyEdge();

	Fig * create_new_item(const Toolkit::MouseEvent * mouse_event, const Drawing::Point &point);
	virtual Object * create_new_edge(const vector<Drawing::Point> & points) = 0;

    protected:
	bool can_start(const Toolkit::MouseEvent * mouse_event);
	bool can_finish(const Toolkit::MouseEvent * mouse_event);

	void finish(const Toolkit::MouseEvent * mouse_event);

    private:
	Object * mStartNode;
	Object * mFinishNode;
    };

} // namespace Diagram

#endif // DIAGRAM_MODE_CREATE_FIG_POLY_EDGE_H
