// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef DRAWING_IMAGE_H
#define DRAWING_IMAGE_H

#include "foundation/object.h"

#include <string>
using namespace std;

namespace Drawing {

    class Image : public Object {
    public:
	virtual int get_w() const = 0;
	virtual int get_h() const = 0;

    protected:
	Image();
	~Image();

	string get_path_to_image(const string & filename) const;
	string get_raw_name(const string & filename) const;
    };

} // namespace Drawing

#endif // DRAWING_IMAGE_H
