// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include <iostream>
#include <string>

#include "foundation/macros.h"

#include "uml/foundation/data_types/name.h"
#include "uml/model_management/package.h"

#include "model-code-generator/generator.h"

using namespace std;
using namespace UML;
using namespace DMCG;

#ifdef DEBUG
int trace_level = 5;
#endif

int
main(int argc, char *argv[]) {
	Generator * dcg = new Generator();

	Package * a_model = new Package(),
			* package_1 = new Package(),
			* package_2 = new Package();

	Name * n = new Name(),
		 * n2 = new Name(),
		 * n3 = new Name();

	n->ref_set_value("TopLevelPackage");
	a_model->set_name(n);
	n2->ref_set_value("Package1");
	package_1->set_name(n2);
	n3->ref_set_value("Package2");
	package_2->set_name(n3);

	a_model->add_owned_element(package_1);
	a_model->add_owned_element(package_2);

	if (dcg->code_generation_on())
		dcg->generate_code(a_model);
	else
		MESSAGE("UML Model Code Generator not provided...");

	// tidy up
	package_2->unref();
	package_1->unref();
    a_model->unref();

	delete(dcg);

    return 0;
}

