// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "foundation/undo_manager.h"

#include "mof/package.h"
#include "mof/model.h"
using namespace MOF;

#ifdef DEBUG
int trace_level = 0;
#endif

int
main() {
#if 0
    Model * model = new Model();

    cout << "Creating a package" << endl;
    Package * package = new Package(model);

    model->set_root(package);

    cout << "Setting the package name" << endl;
    package->set_name("TestPackage");

    cout << "The package's name is now: " << package->get_name() << endl;

    cout << "Setting the package name" << endl;
    package->set_name("PackageUnknown");

    cout << "The package's name is now: " << package->get_name() << endl;

    cout << "*** Undoing ***" << endl;
    UndoManager::instance()->undo();

    cout << "The package's name is now: " << package->get_name() << endl;

    cout << "*** Redoing ***" << endl;
    UndoManager::instance()->redo();

    cout << "The package's name is now: " << package->get_name() << endl;

    cout << "Removing the package" << endl;
    package->remove();

    cout << "Unreferencing the package" << endl;
    package->unref();

    model->remove();
    model->unref();

    UndoManager::instance()->clear();		// flush the undo information

    Object::show_remaining();
#endif

    return 0;
}
