// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "foundation/undo_manager.h"

#include "mof/package.h"
#include "mof/class.h"
#include "mof/model.h"
using namespace MOF;

#ifdef DEBUG
int trace_level = 0;
#endif

int
main() {
#if 0
    Model * model = new Model();

    cout << "Creating package1" << endl;
    Package * package1 = new Package(model);
    model->set_root(package1);
    package1->set_name("Package1");

    cout << "Creating package2" << endl;
    Package * package2 = new Package(model);
    package2->set_name("Package2");

    cout << "Creating class" << endl;
    MOF::Class * klass = new MOF::Class(model);
    klass->set_name("Class");

    cout << "Putting class into package1" << endl;
    klass->set_container(package1);

    cout << "Container of class: " << klass->get_container()->get_name() << endl;

    cout << "Putting class into package2" << endl;
    klass->set_container(package2);

    cout << "Container of class: " << klass->get_container()->get_name() << endl;

    cout << "*** Undoing ***" << endl;
    UndoManager::undo();

    cout << "Container of class: " << klass->get_container()->get_name() << endl;

    cout << "*** Redoing ***" << endl;
    UndoManager::redo();

    cout << "Container of class: " << klass->get_container()->get_name() << endl;


    cout << "Removing the objects" << endl;
    package1->remove();
    package2->remove();
    klass->remove();		// this isn't really necessary because it is
    				// removed when package2 is removed, due to
				// package2 being its owner

    cout << "Unreferencing the objects" << endl;

    klass->unref();
    package2->unref();
    package1->remove();
    package1->unref();

    UndoManager::instance()->clear();		// flush the undo information

    model->remove();
    model->unref();

    Object::show_remaining();
#endif

    return 0;
}
