// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "foundation/undo_manager.h"

#include "mof/model_element.h"
#include "mof/model.h"
#include "mof/writer.h"
#include "mof/model_handler.h"
using namespace MOF;

#include <iostream>
#include <functional>
#include <algorithm>
using namespace std;

#ifdef DEBUG
int trace_level = 0;
#endif

namespace {

    void
    show_details(Object * object) {
	ModelElement * model_element = dynamic_cast<ModelElement *>(object);

	if(model_element) {
	    cerr << model_element->get_name() << endl;
	}
    }

} // namespace {anonymous}

int
main() {
#if 0
    Reader * reader = new Reader();

    try {
	reader->read(cin);
    }
    catch(...) {
	reader->unref();
	cerr << "An exception occurred while reading" << endl;
	throw;
    }

    Model * model = reader->get();

    ModelElement * model_element = model->get_root();

    if(model_element) {
	model_element->ref();

	// now write it back

	Writer * writer = new Writer(model_element);

	writer->write(cout);

	writer->unref();

	// and remove/unref

	model_element->remove();

	model_element->unref();

    }
    else {
	cerr << "Couldn't get root element" << endl;
    }

    reader->unref();

    UndoManager::clear();

    model->remove();
    model->unref();

#ifdef DEBUG
    for_each(Object::get_live_objects().begin(),
	     Object::get_live_objects().end(),
	     ptr_fun(&show_details));
#endif

    Object::show_remaining();
#endif
}
