// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "foundation/undo_manager.h"
#include "foundation/macros.h"

#if 0
#include "reflective/ref_object.h"
#include "reflective/ref_package.h"
#include "reflective/ref_association.h"
#endif

#include "xml/sax_parser.h"

#include "mof/model.h"
#include "mof/package.h"
#include "mof/class.h"
#include "mof/association.h"
#include "mof/model_handler.h"

#include <fstream>
using namespace std;

#ifdef DEBUG
int trace_level = 0;
#endif

int
main() {
#if 0
    MOF::Reader * reader = new MOF::Reader();
    XML::SAXParser * parser = new XML::SAXParser(reader);


    ifstream input("../mof/mof-1.1.xmi");
    ASSERT(input);

    cout << "Reading XMI description of MOF Model 1.1" << endl;

    try {
	parser->parse(input, 2);
    }
    catch(...) {
	cerr << "An exception occured while reading" << endl;
	parser->unref();
	throw;
    }

    cout << "Done reading" << endl;

    MOF::Model * context;
    MOF::ModelElement * root;

    ASSERT(parser->mStack2.size() == 1);
    ASSERT(parser->mStack2.top().size() == 1);

    context = dynamic_cast<MOF::Model *>(parser->mStack2.top().front());

    ASSERT(context);

    root = context->get_root();

    context->ref();

    cout << "-2" << endl;
    reader->unref();
    cout << "-1" << endl;

#if 0
    {
	Package * mof_package = dynamic_cast<Package *>(root);

	ASSERT(mof_package);

	MOF::Class * mof_class = dynamic_cast<MOF::Class *>(mof_package->lookup("Class"));

	ASSERT(mof_class);

	Association * mof_association = dynamic_cast<Association*>(mof_package->lookup("Contains"));

	ASSERT(mof_association);

	// Use the reflective interface to the model

	RefPackage * ref_package = new Model();

	//
	// use the meta-metamodel description to create a metamodel class
	//

	RefObject * ref_class_proxy = ref_package->ref_class_ref(mof_class);

	ASSERT(ref_class_proxy);

	ref_class_proxy->ref();

	list<ValueType *> args;
	RefObject * ref_class_instance = ref_class_proxy->ref_create_instance(args);

	ASSERT(ref_class_instance);

	ref_class_instance->unref();
	ref_class_proxy->unref();

	//
	// use the meta-metamodel description to create an association in the model
	//

	RefAssociation * ref_association = ref_package->ref_association_ref(mof_association);

	ASSERT(ref_association);

	ref_association->ref();

	//ref_association->ref_add_link(make_pair(0, 0));

	ref_association->unref();

	ref_package->unref();
    }
#endif

    cout << "0" << endl;
    root->remove();
    cout << "0.5" << endl;
    root->unref();

    cout << "1" << endl;
    UndoManager::clear();		// flush the undo information
    cout << "2" << endl;
    Object::show_remaining();
    cout << "3" << endl;
#endif

    return 0;
}
