// Dachshund,
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "gtk/settings.h"

#include "foundation/object.h"
#include "toolkit/settings_listener.h"
#include "toolkit/settings_event.h"

#include <iostream>
using namespace std;

#ifdef DEBUG
int trace_level = 0;
#endif

extern "C" {
    int FT_Get_Next_Char;
    int FT_Get_First_Char;
}

namespace {

    const string KEY = "test/1";

} // namespace {anonymous}

class TestListener : public Object, public Toolkit::SettingsListener {
public:
    TestListener() { }
    ~TestListener() { }

    bool value_changed(const Toolkit::SettingsEvent * settings_event) {
	cerr << "got value change event for key: " << settings_event->get_key() << endl;
	return true;
    }
};

int
main(int argc, char * argv[]) {
    GTK::Settings * settings = new GTK::Settings();

    TestListener listener;

    settings->add(&listener);

    bool value = false;

    if(settings->get_value(KEY, value)) {
	cerr << "Got: " << value << endl;

	settings->set_value(KEY, !value);	// toggle the value
    }
    else {
	cerr << "Error getting value" << endl;
    }

    settings->unref();

    return 0;
}
