// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "foundation/undo_manager.h"

#include "reflective/debug_change_listener.h"

#include "uml/uml.h"
#include "uml/foundation/core/class.h"
#include "uml/foundation/data_types/name.h"
#include "uml/model_management/package.h"

#include <iostream>
using namespace std;

#ifdef DEBUG
int trace_level = 0;
#endif

int
main() {
    UML::UML * uml = new UML::UML();

    UndoManager * undo_manager =UndoManager::instance();

    cout << "Creating a class" << endl;

    REF::DebugChangeListener * change_listener = new REF::DebugChangeListener(cerr);

    undo_manager->add_change_listener(change_listener);

    UML::Class * klass = new UML::Class();

#if 0
    UML::Package * package = new UML::Package();
    package->add_owned_element(klass);
#endif

    UML::Name * name = new UML::Name();
    name->ref_set_value("Ben");
    klass->set_name(name);
    klass->set_name(name);
    klass->set_name(name);
    klass->set_name(name);
    klass->set_name(name);
    klass->set_name(name);
    klass->set_name(name);
    klass->set_name(name);
    name->unref();

    undo_manager->undo();
    undo_manager->undo();
    undo_manager->undo();
    undo_manager->undo();

    klass->unref();

#if 0
    package->unref();
#endif

    undo_manager->remove_change_listener(change_listener);

    change_listener->unref();

    uml->unref();

    UndoManager::shutdown();

    Object::show_remaining();

    return 0;
}
