// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include <iostream>
using namespace std;

#include "foundation/undo_manager.h"

#include "xml/node.h"
#include "xml/property.h"
using namespace XML;

#ifdef DEBUG
int trace_level = 0;
#endif

int
main() {
    Node * node1 = new Node();
    node1->set_name("Car");

    Property * prop1 = new Property("black", "green");
    node1->add_property(prop1);
    prop1->unref();

    Property * prop2 = new Property("black", "green");
    node1->add_property(prop2);
    prop2->unref();

    Node * node1_1 = new Node();
    node1_1->set_name("Wheel1");
    node1->add_child(node1_1);
    node1_1->unref();

    Node * node1_2 = new Node();
    node1_2->set_name("Wheel2");
    node1->add_child(node1_2);
    node1_2->unref();

    cout << *node1;

    node1->unref();

    return 0;
}
