// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef FOUNDATION_STANDARD_EXCEPTIONS_H
#define FOUNDATION_STANDARD_EXCEPTIONS_H

#include "exception.h"

#include <string>
using namespace std;

class FileNotFoundException : public Exception {
public:
    explicit FileNotFoundException(const string & filename) : Exception("File not found",
									"Filename: " + filename) { }
    ~FileNotFoundException() { }
};

class OddityException : public Exception {
public:
    explicit OddityException(const string & details) : Exception("Oddity", details) { }
    ~OddityException() { }
};

#endif // FOUNDATION_STANDARD_EXCEPTIONS_H
