// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GTK_LOG_H
#define GTK_LOG_H

#include "toolkit/log.h"
#include "widget.h"

#include <gtk/gtktextbuffer.h>

namespace GTK {

    class Log : public Toolkit::Log, public Widget {
    public:
	Log();
	~Log();

	void log(const string & message, Toolkit::LogLevel level);
	void clear();

    private:
	GtkTextBuffer * mTextBuffer;
	GtkWidget * mTextView;
    };

} // namespace GTK

#endif // GTK_LOG_H
