// Dachshund					-*- C++ -*-
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GTK_MARK_H
#define GTK_MARK_H

#include "toolkit/mark.h"

#include <gtk/gtktextview.h>

namespace GTK {

    class Mark : public Toolkit::Mark {
    public:
        Mark(const char * name, GtkTextMark * gtkmark);
        Mark(const char * name, Toolkit::Mark * location, bool left_gravity = true);
        ~Mark();

        // Toolkit::Mark methods
        void	relocate_to_mark(Toolkit::Mark * mark);
        void	relocate_to_tag_end(Toolkit::Tag * tag);

        bool	at_tag_start(Toolkit::Tag * tag);
        bool	at_tag_end(Toolkit::Tag * tag);



        // GTK specific methods
        GtkTextMark * get_gtkmark() { return mGtkMark; }

    protected:


    private:
        GtkTextMark * mGtkMark;
    };

} // namespace GTK

#endif // GTK_MARK_H
