// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "notebook.h"

#include "foundation/macros.h"
#include "foundation/utility.h"

#include <gtk/gtknotebook.h>

namespace GTK {

    Notebook::Notebook() : Toolkit::Notebook(), Widget() {
	mBaseWidget = gtk_notebook_new();

	gtk_notebook_set_show_border(GTK_NOTEBOOK(mBaseWidget), FALSE);
	gtk_notebook_set_show_tabs(GTK_NOTEBOOK(mBaseWidget), FALSE);

	post_init();
    }

    Notebook::~Notebook() {
    }

    void
    Notebook::add(Toolkit::Widget * widget) {
	ASSERT(widget);

	Widget * _widget = known_cast<Widget *>(widget);

	gtk_notebook_append_page(GTK_NOTEBOOK(mBaseWidget), _widget->get_base_widget(), 0);
    }

    void
    Notebook::set_current(Toolkit::Widget * widget) {
	Widget * _widget = known_cast<Widget *>(widget);

	int page_num = gtk_notebook_page_num(GTK_NOTEBOOK(mBaseWidget), _widget->get_base_widget());
	gtk_notebook_set_current_page(GTK_NOTEBOOK(mBaseWidget), page_num);
    }

    Toolkit::Widget *
    Notebook::find_if(bool (*callback)(Toolkit::Widget *, void *), void * data) {
	NYI();

	// FIXME I don't think this is needed...

	return 0;

#if 0
	GList * children = _NOTEBOOK(mBaseWidget)->children;

	while(children) {
	    GtkNotebookCh

	    children = children->next;
	}
#endif
    }

} // namespace GTK
