// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GTK_PALETTE_H
#define GTK_PALETTE_H

#include "toolkit/palette.h"
#include "widget.h"

namespace GTK {

    class Palette : public Toolkit::Palette, public Widget {
    public:
	Palette();
	~Palette();

	void add_element(Command * command, Drawing::Image * image);
	void add_separator();
	void set_current(Command * command);
	Command * find_if(bool (*callback)(Command *, void *), void * data = 0);

    protected:
	GtkWidget * find(const Command * command);

    private:
	static void static_toolbar_callback(GtkWidget * widget, Palette * palette);
	void toolbar_callback(GtkWidget * widget);

	static void static_unref(gpointer data);
    };

} // namespace GTK

#endif // GTK_PALETTE_H
