// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GTK_SETTINGS_H
#define GTK_SETTINGS_H

#include "toolkit/settings.h"

#include <gconf/gconf-client.h>

namespace GTK {

    class Settings : public Toolkit::Settings {
    public:
	Settings();
	~Settings();

	bool get_value(const string & key, string & value) const;
	bool get_value(const string & key, int & value) const;
	bool get_value(const string & key, bool & value) const;
	bool get_value(const string & key, double & value) const;

	void set_value(const string & key, const string & value);
	void set_value(const string & key, int value);
	void set_value(const string & key, bool value);
	void set_value(const string & key, double value);

    private:
	static void static_client_notify(GConfClient * client, guint connection_id,
					 GConfEntry * entry, gpointer user_data);
	void client_notify(GConfClient * client, guint connection_id, GConfEntry * entry);

	GConfClient * mClient;
	unsigned int mConnection;

	static const string KEY_PREFIX;
    };

} // namespace GTK

#endif // GTK_SETTINGS_H
