// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GTK_TEXT_H
#define GTK_TEXT_H

#include "drawing/text.h"

#include <pango/pango-layout.h>
#include <gtk/gtkwidget.h>

namespace GTK {

    class Text : public Drawing::Text {
    public:
	Text();
	~Text();

	PangoLayout * get_layout() { return mLayout; }

	static void set_widget(GtkWidget * widget);

	void set_text(const string & text);
	void set_wrap_mode(WrapMode wrap_mode);
	void set_alignment(Alignment alignment);
	void set_font(const string & font_name);
	int set_width(int width);

    protected:

    private:
	PangoLayout * mLayout;

	static GtkWidget * mWidget;
    };

} // namespace GTK

#endif // GTK_TEXT_H
