// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef GTK_WIDGET_H
#define GTK_WIDGET_H

#include "toolkit/widget.h"

#include <gtk/gtkwidget.h>

// this class is sorta like VkWidget from ViewKit, i.e., piss-weak

namespace GTK {

    class Widget : public virtual Toolkit::Widget {
    public:
	Widget();
	virtual ~Widget();

	GtkWidget * get_base_widget() { return mBaseWidget; }

	void show();
	void hide();

	void attach_object(Object * object);
	Object * get_object();

    protected:
	void post_init();

	GtkWidget * mBaseWidget;

	static int translate_modifiers(int i);
	static int translate_presses(int i);

    private:
	static void static_destroy_callback(GtkWidget * widget, Widget * _widget);
	void destroy_callback(GtkWidget * widget);

	unsigned int mDestroyHandler;
    };

} // namespace GTK

#endif // WIDGET_H
