// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef MOF_ATTRIBUTE_H
#define MOF_ATTRIBUTE_H

#include "structural_feature.h"

#include "boolean.h"

namespace MOF {

    class Model;
    class Attribute;

    //

    class Attribute : public StructuralFeature {
    public:
	Attribute();
	~Attribute();

	const Boolean * is_derived() const { return mDerived; }
	void set_derived(const Boolean * derived);

    protected:
	// reflective

	bool ref_is_a_type_of_impl(set<string> & visited, const string & class_name) const;
	const string & ref_get_type() const;

	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();

    private:
	Boolean * mDerived;

	static const string TYPE;
    };

} // namespace MOF

typedef MOF::Attribute MOFAttribute;

#endif // MOF_ATTRIBUTE_H
