// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef MOF_CLASSIFIER_H
#define MOF_CLASSIFIER_H

#include "generalizable_element.h"

#include <set>
using namespace std;

namespace MOF {

    using namespace Common;

    class Model;
    class TypedElement;

    //

    class Classifier : public GeneralizableElement {
    public:

	// internal

	void internal_add_typed_element(TypedElement * typed_element) throw();
	void internal_remove_typed_element(TypedElement * typed_element) throw();

    protected:
	Classifier();
	~Classifier();

	// reflective

	void ref_delete_impl(set<string> & visited);

	bool ref_is_a_type_of_impl(set<string> & visited, const string & class_name) const;
	const string & ref_get_type() const;

	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();

    private:
	set<TypedElement *> mTypedElements;

	static const string TYPE;
    };

} // namespace MOF

#endif // MOF_CLASSIFIER_H
