// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef MOF_FEATURE_H
#define MOF_FEATURE_H

#include "model_element.h"

#include "visibility_kind.h"
#include "scope_kind.h"

#include <iosfwd>
using namespace std;

namespace MOF {

    class Model;

    //

    class Feature : public virtual ModelElement {
    public:
	const VisibilityKind * get_visibility() const { return mVisibility; }
	void set_visibility(const VisibilityKind * visibility);

	const ScopeKind * get_scope() const { return mScope; }
	void set_scope(const ScopeKind * scope);

    protected:
	Feature();
	~Feature();

	// reflective

	bool ref_is_a_type_of_impl(set<string> & visited, const string & class_name) const;
	const string & ref_get_type() const;

	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();

    private:
	VisibilityKind * mVisibility;
	ScopeKind * mScope;

	static const string TYPE;
    };

} // namespace MOF

#endif // MOF_FEATURE_H
