// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef MULTIPLICITY_TYPE_H
#define MULTIPLICITY_TYPE_H

#include "reflective/attribute.h"

#include "boolean.h"
#include "integer.h"

namespace MOF {

    class MultiplicityType : public REF::Attribute {
    public:
	MultiplicityType();
	MultiplicityType(const MultiplicityType & mt);
	~MultiplicityType();

	void ref_set_value(const string & value);
	void ref_get_value(string & value) const;

	const string & ref_get_type() const;

	//

	const Integer * get_lower() const { return mLower; }
	void set_lower(const Integer * lower);

	const Integer * get_upper() const { return mUpper; }
	void set_upper(const Integer * upper);

	const Boolean * get_ordered() const { return mOrdered; }
	void set_ordered(const Boolean * ordered);

	const Boolean * is_unique() const { return mUnique; }
	void set_unique(const Boolean * unique);

    private:
	Integer * mLower;
	Integer * mUpper;
	Boolean * mOrdered;
	Boolean * mUnique;

	static const string TYPE;
    };

} // namespace MOF

#endif // MULTIPLICITY_TYPE_H
