// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef MOF_PACKAGE_H
#define MOF_PACKAGE_H

#include "generalizable_element.h"

#include <iostream>
using namespace std;

namespace MOF {

    using namespace Common;

    const string PACKAGE_CONTAINMENT_RULES =
	"org.omg.mof:constraint.model.package.package_containment_rules";
    const string PACKAGES_CANNOT_BE_ABSTRACT =
	"org.omg.mof:constraint.model.package.packages_cannot_be_abstract";

    typedef string FormatType;

    struct FormatNotSupported {
    };

    struct ObjectNotExternalizable {
    };

    struct IllformedExternalizedObject {
    };

    class Model;
    class Package;

    //

    class Package : public GeneralizableElement {
    public:
	Package();
	~Package();

#if 0
	void externalize(FormatType format);
	void internalize(FormatType format, istream & stream);
#endif

	// internal

    protected:
	// reflective

	bool ref_is_a_type_of_impl(set<string> & visited, const string & class_name) const;
	const string & ref_get_type() const;

	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();

    private:

	static const string TYPE;
    };

} // namespace MOF

#endif // MOF_PACKAGE_H
