// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef PYTHON_CONVERT_H
#define PYTHON_CONVERT_H

#include <Python.h>


// from foundation/object.h
class Object;

namespace REF {
  class Class;
  class Context;
}

namespace Toolkit {
  class Tree;
  class Widget;
  class Document;
  class Tag;
  class Mark;
  class MouseEvent;
  class ChangeEvent;
}

namespace Drawing {
  class Image;
}


namespace Python {

  // Type conversion function
  bool convert_to_object(Object *& result, PyObject * obj);
  bool convert_to_class(REF::Class *& result, PyObject * obj);
  bool convert_to_context(REF::Context *& result, PyObject * obj);
  bool convert_to_widget(Toolkit::Widget *& result, PyObject * obj);
  bool convert_to_tree(Toolkit::Tree *& result, PyObject * obj);
  bool convert_to_document(Toolkit::Document *& result, PyObject * obj);
  bool convert_to_tag(Toolkit::Tag *& result, PyObject * obj);
  bool convert_to_mark(Toolkit::Mark *& result, PyObject * obj);
  bool convert_to_image(Drawing::Image *& result, PyObject * obj);
  bool convert_to_mouse_event(const Toolkit::MouseEvent *& result, PyObject * obj);

}

#endif
