// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef PYTHON_FOUNDATION_OBJECT_H
#define PYTHON_FOUNDATION_OBJECT_H

#include <Python.h>


// from foundation/object.h
class Object;

namespace Python {

  struct ObjectReference {
    // Python reference to Object
    PyObject_HEAD
    Object * mObject;

    Object *		get() { return mObject; }
    const Object *	get_as_const() { return mObject; }
    void set(Object * o) { mObject = o; }
  };


  // Forward declaration of the type descriptor
  extern PyTypeObject foundationObjectType;


  // Declaration of the module initialisation function
  extern PyObject * object_reference_new(Object * obj);
  extern PyObject * object_reference_new(PyObject * self, PyObject * args);
}


#endif
