// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "foundation/macros.h"

#include "python/toolkit/widget.h"
#include "python/toolkit/tree.h"
#include "python/toolkit/document.h"
#include "python/toolkit/tag.h"
#include "python/toolkit/mark.h"
#include "python/toolkit/menu.h"
#include "python/toolkit/module.h"

namespace Python {

  void toolkit_initialise() {
    static struct PyMethodDef toolkit_methods[] = {
//      { "Widget", toolkit_widget_reference_new, METH_VARARGS },
//      { "Tree",   toolkit_tree_reference_new,   METH_VARARGS },
      { "Document", document_reference_new,	METH_VARARGS },
      { "Tag",      tag_reference_new_tag,	METH_VARARGS },
      { "Block",    tag_reference_new_block,	METH_VARARGS },
      { "Field",    tag_reference_new_field,	METH_VARARGS },
      { "Menu",     menu_reference_new,		METH_VARARGS },
      { "Mark",	    mark_reference_new_mark,	METH_VARARGS },
      { "BlockMark",mark_reference_new_block_mark, METH_VARARGS },

      { NULL, NULL }
    };

    TRACE(1, "Initialise Toolkit interface...");
    Py_InitModule("Toolkit", toolkit_methods);
  }

}

