// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef PYTHON_TOOLKIT_MOUSE_EVENT_H
#define PYTHON_TOOLKIT_MOUSE_EVENT_H

namespace Toolkit {

  class Widget;
  class MouseEvent;
}

#include <Python.h>

namespace Python {

  struct MouseEventReference {
    // Python reference to Toolkit::MouseEvent
    PyObject_HEAD
    const Toolkit::MouseEvent * mMouseEvent;

    const Toolkit::MouseEvent * get() { return mMouseEvent; }
  };


  // Forward declaration of the type descriptor
  extern PyTypeObject toolkitMouseEventType;


  // Declaration of the module initialisation function
  PyObject * mouse_event_reference_new(const Toolkit::MouseEvent * event);
}

#endif
