// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "enum.h"

#include "exceptions.h"

namespace REF {

    Enum::Enum() : Attribute(),
        mValue(0) {
    }

    Enum::~Enum() {
    }

    void
    Enum::ref_set_value(const string & value) {
	for(int i = 0; i < get_size(); ++i) {
	    if(get_values()[i] == value) {
		mValue = i;
		return;
	    }
	}

	throw BadValue("No such enum literal: " + value);
    }

    void
    Enum::ref_get_value(string & value) const {
	value += get_values()[get_int_value()];
    }

    void
    Enum::set_int_value(int value) {
	if(value < get_size()) {
	    mValue = value;
	}
	else {
	    throw BadValue("Int value out of range for enum: " + value);
	}
    }

} // namespace REF
