// Dachshund
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef REFLECTIVE_EXCEPTIONS_H
#define REFLECTIVE_EXCEPTIONS_H

#include "foundation/exception.h"

namespace REF {

    class Exception : public ::Exception {
    public:
	~Exception();
    protected:
	Exception(const string & name, const string & details);
    };


    class NotFound : public Exception {
    public:
	explicit NotFound(const string & details);
	~NotFound();
    };


    class BadType : public Exception {
    public:
	explicit BadType(const string & details);
	~BadType();
    };


    class NotSet : public Exception {
    public:
	explicit NotSet(const string & details);
	~NotSet();
    };


    class BadValue : public Exception {
    public:
	explicit BadValue(const string & details);
	~BadValue();
    };


    class BadPosition : public Exception {
    public:
	explicit BadPosition(const string & details);
	~BadPosition();
    };

} // namespace REF

#endif // REFLECTIVE_EXCEPTIONS_H
