// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef TOOLKIT_CANVAS_EVENT_H
#define TOOLKIT_CANVAS_EVENT_H

#include "gui_event.h"

#include "drawing/rectangle.h"

namespace Toolkit {

    class Canvas;

    class CanvasEvent : public GuiEvent {
    public:
	CanvasEvent(Canvas * canvas, const Drawing::Rectangle & rect);
	~CanvasEvent();

	Canvas * get_canvas() const { return mCanvas; }
	const Drawing::Rectangle & get_area() const { return mArea; }

	int get_x() const { return mArea.get_x(); }
	int get_y() const { return mArea.get_y(); }
	int get_w() const { return mArea.get_w(); }
	int get_h() const { return mArea.get_h(); }

    private:
	Canvas * mCanvas;
	Drawing::Rectangle mArea;
    };

} // namespace Toolkit

#endif // TOOLKIT_CANVAS_EVENT_H
