// Dachshund					-*- C++ -*-
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef TOOLKIT_DOCUMENT_MAINTAINER_H
#define TOOLKIT_DOCUMENT_MAINTAINER_H

#include "foundation/object.h"

#include <string>
#include <list>
using namespace std;

namespace Toolkit {

  class Document;

  class DocumentMaintainer {
  public:
    // This method is called if a change occurs within any Tag sensitive to changes
    virtual void changed(Object * object, 
			 Toolkit::Mark * block_mark, Toolkit::Tag * block, 
			 Toolkit::Mark * field_mark_begin, Toolkit::Mark * field_mark_end,
			 Toolkit::Tag * field) = 0;

    // This method is called to sync changes made in document with model
    // It is called just once to apply the changes when cursor moves out of changed area
    virtual void apply_change(Object * object,
			      Toolkit::Mark * block_mark, Toolkit::Tag * block, 
			      Toolkit::Mark * field_mark_begin, Toolkit::Mark * field_mark_end, 
			      Toolkit::Tag * field) = 0;

    // These methods are called when insertion point enters/exits sensitive tags
    //virtual void enter(Document * document, list<Tag *> location);
    //virtual void leave(Document * document, list<Tag *> location);

    //virtual void relocated(Tree * tree, Object * node, Object * new_parent) = 0;    
    //virtual void renamed(Tree * tree, Object * node, const string & name) = 0;
    //virtual void selection(const set<Object *> & nodes) = 0;
  };

} // namespace Toolkit

#endif // TOOLKIT_DOCUMENT_MAINTAINER_H
