// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef TOOLKIT_MENU_H
#define TOOLKIT_MENU_H

#include "widget.h"

#include <string>
using namespace std;

class Command;

namespace Toolkit {

    enum MenuKind {
	MK_BAR,
	MK_NORMAL,
	MK_OPTION
    };

    class MouseEvent;

    class Menu : public virtual Widget {
    public:
	Menu();
	~Menu();

	virtual void popup(const MouseEvent * mouse_event) = 0;

	virtual void add_push(Command * command, const string & label, bool sensitive = true) = 0;
	virtual void add_check(Command * command, const string & label, bool sensitive = true) = 0;
	virtual void add_radio(Command * command, const string & label, Command * group,
			    bool sensitive = true) = 0;
	virtual void add_submenu(Menu * submenu, const string & label) = 0;
	virtual void add_separator() = 0;

	virtual void set_sensitive(Command * command, bool sensitive) = 0;
	virtual void set_state(Command * command, bool state) = 0;	// for radio/check buttons

    protected:

    private:
    };

} // namespace Toolkit

#endif // TOOLKIT_MENU_H
