// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef TOOLKIT_MOUSE_LISTENER_H
#define TOOLKIT_MOUSE_LISTENER_H

// interface class only

namespace Toolkit {

    class MouseEvent;

    class MouseListener {
    public:
	virtual bool mouse_entered(const MouseEvent * mouse_event) = 0;
	virtual bool mouse_exited(const MouseEvent * mouse_event) = 0;
	virtual bool mouse_pressed(const MouseEvent * mouse_event) = 0;
	virtual bool mouse_released(const MouseEvent * mouse_event) = 0;
	virtual bool mouse_moved(const MouseEvent * mouse_event) = 0;
	virtual bool mouse_dragged(const MouseEvent * mouse_event) = 0;
    };

} // namespace Toolkit

#endif // TOOLKIT_MOUSE_LISTENER_H
