// Dachshund,
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_EXT_FIG_EDGE_H
#define UML_EXT_FIG_EDGE_H

#include "diagram/fig_edge.h"

#include "uml/diagram/presentation_element.h"

namespace UMLExt {

    class FigGimlet;
    class FigNode;

    class FigEdge : public Diagram::FigEdge {
    public:
	~FigEdge();

	void paint(Drawing::Drawable * drawable) const;

	void set_layer(Diagram::Layer * layer);

	void cleanup();

	void begin_interaction();
	void end_interaction();

        void update_to_owner();

    protected:
	FigEdge(UML::PresentationElement * pe, FigNode * source, FigNode * destination);

	void update_bounds_to_points();

	FigGimlet * mSourceGimlet;
	FigGimlet * mDestinationGimlet;

	void update_gimlets();

    private:
    };

} // namespace UMLExt

#endif // UML_EXT_FIG_EDGE_H
