// Dachshund,
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_EXT_FIG_GIMLET_H
#define UML_EXT_FIG_GIMLET_H

#include "diagram/fig_poly.h"

namespace UMLExt {

    enum GimletKind {
	GK_NULL,
	GK_ARROW,
	GK_DIAMOND
    };

    class FigGimlet : public Diagram::FigPoly {
    public:
	explicit FigGimlet(GimletKind kind = GK_NULL);
	~FigGimlet();

	void paint(Drawing::Drawable * drawable) const;

	void set_control_points(const Drawing::Point & source, const Drawing::Point & destination);
	void set_kind(GimletKind kind);

    protected:
	void update_points();

    private:
	Drawing::Point mSource, mDestination;
	GimletKind mKind;
    };

} // namespace UMLExt

#endif // UML_EXT_FIG_GIMLET_H
