// Dachshund,
// Copyright (C) 2002 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_EXT_FIG_NOTE_H
#define UML_EXT_FIG_NOTE_H

#include "fig_node.h"

#include "uml/diagram/comment_presentation.h"

#include "diagram/fig_text.h"
#include "diagram/fig_poly_line.h"

namespace UMLExt {

    class FigNote : public FigNode {
    public:
	explicit FigNote(UML::CommentPresentation * cp);
	~FigNote();

        void update_to_owner();

    protected:
        void layout();

    private:
        Diagram::FigPolyLine * mBaseFig;
        Diagram::FigPolyLine * mOutlineFig;
        Diagram::FigPolyLine * mFlapFig;
	Diagram::FigText * mBodyFig;
    };

} // namespace UMLExt

#endif // UML_EXT_FIG_NOTE_H
