// Dachshund
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UMLEXT_MODE_CREATE_POLY_EDGE_H
#define UMLEXT_MODE_CREATE_POLY_EDGE_H

#include "diagram/mode_create_fig_poly_edge.h"

#include "foundation/macros.h"

#include "uml/foundation/data_types/name.h"

#include <sstream>
using namespace std;

namespace UMLExt {

    template<class T>
    class ModeCreatePolyEdge : public Diagram::ModeCreateFigPolyEdge {
    public:
	ModeCreatePolyEdge();
	~ModeCreatePolyEdge();

	Object * create_new_edge(const vector<Drawing::Point> & points);
	string get_instructions() const;

    private:
    };

    template<class T>
    ModeCreatePolyEdge<T>::ModeCreatePolyEdge() : ModeCreateFigPolyEdge() {
    }

    template<class T>
    ModeCreatePolyEdge<T>::~ModeCreatePolyEdge() {
    }

    template<class T>
    Object *
    ModeCreatePolyEdge<T>::create_new_edge(const vector<Drawing::Point> & points) {
	T * t = new T();

	ostringstream ost;

	for(unsigned int i = 1; i < points.size() - 1; ++i) {
	    ost << points[i];
	}

	UML::Name * str = new UML::Name();
	str->ref_set_value(ost.str());
	t->set_geometry(str);
	str->unref();

	return t;
    }

    template<class T>
    string
    ModeCreatePolyEdge<T>::get_instructions() const {
	return "Click to create edge";
    }

} // namespace UMLExt

#endif // UMLEXT_MODE_CREATE_POLY_EDGE_H
