// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "generalization_presentation.h"

#include "class_presentation.h"

#include "uml.h"

#include "reflective/changes.h"
#include "reflective/set_iterator.h"
#include "reflective/list_iterator.h"
#include "reflective/pointer_iterator.h"
#include "reflective/exceptions.h"

#include "foundation/macros.h"
#include "foundation/commands.h"
#include "foundation/utility.h"
#include "foundation/exception.h"
#include "foundation/algorithm.h"
#include "foundation/functional.h"

#include <vector>
#include <functional>
#include <algorithm>
using namespace std;

namespace UML {
    
    const string GeneralizationPresentation::TYPE = "GeneralizationPresentation";
    
    GeneralizationPresentation::GeneralizationPresentation() {
	mSubtype = 0;
	mSupertype = 0;
	
	TRACE(9, "Constructed: " << static_cast<Object *>(this));
    }
    
    GeneralizationPresentation::GeneralizationPresentation(const GeneralizationPresentation & generalization_presentation) {
	ASSERT_NOT_REACHED();
    }
    
    GeneralizationPresentation::~GeneralizationPresentation() {
	TRACE(9, "Destroyed: " << static_cast<Object *>(this));
	
    }
    
    void // MMM
    GeneralizationPresentation::internal_set_subtype(ClassPresentation * subtype) {
	ChangeEvent * change = change_role_changed(this, "subtype",
						   subtype, mSubtype, false);
	log_change(change);
	
	change->unref();
	
	if(mSubtype) {
	    mSubtype->unref();
	}
	
	mSubtype = subtype;
	
	if(mSubtype) {
	    mSubtype->ref();
	}
    }
    
    void // LLL
    GeneralizationPresentation::set_subtype(ClassPresentation * subtype) {
	if(mSubtype != subtype) {
	    // neither end is an aggregate, so we must have the same context
	    // as each other
	    
	    if(subtype) {
		ASSERT(!subtype->ref_get_context() ||
		       subtype->ref_get_context() == ref_get_context());
	    }
	    
	    begin_transaction();
	    
	    Command * command = command_flip_argument(this,
						      &GeneralizationPresentation::set_subtype,
						      subtype, mSubtype);
	    log_command(command);
	    command->unref();
	    
	    ChangeEvent * change = change_role_changed(this,
						       "subtype", subtype,
						       mSubtype, false);
	    log_change(change);
	    change->unref();
	    
	    if(mSubtype) {
		mSubtype->internal_remove_generalization(this);
		mSubtype->unref();
	    }
	    
	    mSubtype = subtype;
	    
	    if(mSubtype) {
		mSubtype->internal_add_generalization(this);
		mSubtype->ref();
	    }
	    
	    end_transaction();
	}
    }
    
    void // MMM
    GeneralizationPresentation::internal_set_supertype(ClassPresentation * supertype) {
	ChangeEvent * change = change_role_changed(this, "supertype",
						   supertype, mSupertype, false);
	log_change(change);
	
	change->unref();
	
	if(mSupertype) {
	    mSupertype->unref();
	}
	
	mSupertype = supertype;
	
	if(mSupertype) {
	    mSupertype->ref();
	}
    }
    
    void // LLL
    GeneralizationPresentation::set_supertype(ClassPresentation * supertype) {
	if(mSupertype != supertype) {
	    // neither end is an aggregate, so we must have the same context
	    // as each other
	    
	    if(supertype) {
		ASSERT(!supertype->ref_get_context() ||
		       supertype->ref_get_context() == ref_get_context());
	    }
	    
	    begin_transaction();
	    
	    Command * command = command_flip_argument(this,
						      &GeneralizationPresentation::set_supertype,
						      supertype, mSupertype);
	    log_command(command);
	    command->unref();
	    
	    ChangeEvent * change = change_role_changed(this,
						       "supertype", supertype,
						       mSupertype, false);
	    log_change(change);
	    change->unref();
	    
	    if(mSupertype) {
		mSupertype->internal_remove_specialization(this);
		mSupertype->unref();
	    }
	    
	    mSupertype = supertype;
	    
	    if(mSupertype) {
		mSupertype->internal_add_specialization(this);
		mSupertype->ref();
	    }
	    
	    end_transaction();
	}
    }
    
    void
    GeneralizationPresentation::ref_set_context_impl(set<string> & visited,
						     REF::Context * context) {
	if(visited.insert(TYPE).second) {
	    EdgeElement::ref_set_context_impl(visited, context);
	}
    }
    
    void
    GeneralizationPresentation::ref_implant_impl(set<string> & visited) throw() {
	if(visited.insert(TYPE).second) {
	    REF::Context * context = ref_get_context();
	    
	    ASSERT(context);
	    
	    UML * model = known_cast<UML *>(context);
	    
	    model->internal_add_generalization_presentation(this);
	    
	    EdgeElement::ref_implant_impl(visited);
	}
    }
    
    void
    GeneralizationPresentation::ref_uproot_impl(set<string> & visited) throw() {
	if(visited.insert(TYPE).second) {
	    EdgeElement::ref_uproot_impl(visited);
	    
	    REF::Context * context = ref_get_context();
	    
	    ASSERT(context);
	    
	    UML * model = known_cast<UML *>(context);
	    
	    model->internal_add_generalization_presentation(this);
	}
    }
    
    bool
    GeneralizationPresentation::ref_add_role_impl(set<string> & visited,
						  const string & role_name,
						  REF::Class * role,
						  REF::Class * position) {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_add_role_impl(visited, role_name, role, position)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_remove_role_impl(set<string> & visited,
						     const string & role_name,
						     REF::Class * role) {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_remove_role_impl(visited, role_name, role)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_get_role_impl(set<string> & visited,
						  REF::Class * & role,
						  const string & role_name) {
	if(visited.insert(TYPE).second) {
	    if(role_name == "subtype") {
		role = get_subtype();
		return true;
	    }
	    
	    if(role_name == "supertype") {
		role = get_supertype();
		return true;
	    }
	    
	    if(EdgeElement::ref_get_role_impl(visited, role, role_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_set_role_impl(set<string> & visited,
						  const string & role_name,
						  REF::Class * role) {
	if(visited.insert(TYPE).second) {
	    if(role_name == "subtype") {
		ClassPresentation * subtype = dynamic_cast<ClassPresentation *>(role);
		
		if(!subtype) {
		    WARNING("Wrong type for role: " + role->ref_get_type() +
			    ", in class: " + ref_get_type());
		    throw REF::BadType("Wrong type for role: " + role->ref_get_type());
		}
		
		set_subtype(subtype);
		return true;
	    }
	    
	    if(role_name == "supertype") {
		ClassPresentation * supertype = dynamic_cast<ClassPresentation *>(role);
		
		if(!supertype) {
		    WARNING("Wrong type for role: " + role->ref_get_type() +
			    ", in class: " + ref_get_type());
		    throw REF::BadType("Wrong type for role: " + role->ref_get_type());
		}
		
		set_supertype(supertype);
		return true;
	    }
	    
	    if(EdgeElement::ref_set_role_impl(visited, role_name, role)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_create_class_impl(set<string> & visited,
						      REF::Class * & role,
						      const string & role_name) const {
	if(visited.insert(TYPE).second) {
	    if(role_name == "subtype") {
		role = new ClassPresentation();
		return true;
	    }
	    
	    if(role_name == "supertype") {
		role = new ClassPresentation();
		return true;
	    }
	    
	    if(EdgeElement::ref_create_class_impl(visited, role, role_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_get_role_iterator_impl(set<string> & visited,
							   REF::Iterator * & iterator,
							   const string & role_name) {
	if(visited.insert(TYPE).second) {
	    if(role_name == "subtype") {
		iterator = REF::iterator<ClassPresentation>(get_subtype());
		return true;
	    }
	    
	    if(role_name == "supertype") {
		iterator = REF::iterator<ClassPresentation>(get_supertype());
		return true;
	    }
	    
	    if(EdgeElement::ref_get_role_iterator_impl(visited, iterator, role_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_get_attribute_impl(set<string> & visited,
						       const REF::Attribute * & attribute,
						       const string & attribute_name) const {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_get_attribute_impl(visited, attribute, attribute_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_set_attribute_impl(set<string> & visited,
						       const string & attribute_name,
						       const REF::Attribute * attribute) {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_set_attribute_impl(visited, attribute_name, attribute)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_get_attribute_set_impl(set<string> & visited,
							   const vector<const REF::Attribute *> * & attribute_set,
							   const string & attribute_name) const {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_get_attribute_set_impl(visited, attribute_set, attribute_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_set_attribute_set_impl(set<string> & visited,
							   const string & attribute_name,
							   const vector<const REF::Attribute *> * attribute_set) {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_set_attribute_set_impl(visited, attribute_name, attribute_set)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_create_attribute_impl(set<string> & visited,
							  REF::Attribute * & attribute,
							  const string & attribute_name) const {
	if(visited.insert(TYPE).second) {
	    if(EdgeElement::ref_create_attribute_impl(visited, attribute, attribute_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    GeneralizationPresentation::ref_is_a_type_of_impl(set<string> & visited,
						      const string & class_name) const {
	if(visited.insert(TYPE).second) {
	    if(class_name == "GeneralizationPresentation") {
		return true;
	    }
	    
	    if(EdgeElement::ref_is_a_type_of_impl(visited, class_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    const string &
    GeneralizationPresentation::ref_get_type() const {
	return TYPE;
    }
    
    void
    GeneralizationPresentation::ref_delete_impl(set<string> & visited) {
	if(visited.insert(TYPE).second) {
	    ClassPresentation * subtype = 0;
	    set_subtype(subtype);
	    
	    ClassPresentation * supertype = 0;
	    set_supertype(supertype);
	    
	    EdgeElement::ref_delete_impl(visited);
	}
    }
    
} // namespace UML
