// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "association_class.h"

#include "uml.h"

#include "reflective/changes.h"
#include "reflective/set_iterator.h"
#include "reflective/list_iterator.h"
#include "reflective/pointer_iterator.h"
#include "reflective/exceptions.h"

#include "foundation/macros.h"
#include "foundation/commands.h"
#include "foundation/utility.h"
#include "foundation/exception.h"
#include "foundation/algorithm.h"
#include "foundation/functional.h"

#include <vector>
#include <functional>
#include <algorithm>
using namespace std;

namespace UML {
    
    const string AssociationClass::TYPE = "AssociationClass";
    
    AssociationClass::AssociationClass() {
	
	TRACE(9, "Constructed: " << static_cast<Object *>(this));
    }
    
    AssociationClass::AssociationClass(const AssociationClass & association_class) {
	ASSERT_NOT_REACHED();
    }
    
    AssociationClass::~AssociationClass() {
	TRACE(9, "Destroyed: " << static_cast<Object *>(this));
	
    }
    
    void
    AssociationClass::ref_set_context_impl(set<string> & visited,
					   REF::Context * context) {
	if(visited.insert(TYPE).second) {
	    Association::ref_set_context_impl(visited, context);
	    Class::ref_set_context_impl(visited, context);
	}
    }
    
    void
    AssociationClass::ref_implant_impl(set<string> & visited) throw() {
	if(visited.insert(TYPE).second) {
	    REF::Context * context = ref_get_context();
	    
	    ASSERT(context);
	    
	    UML * model = known_cast<UML *>(context);
	    
	    model->internal_add_association_class(this);
	    
	    Association::ref_implant_impl(visited);
	    
	    Class::ref_implant_impl(visited);
	}
    }
    
    void
    AssociationClass::ref_uproot_impl(set<string> & visited) throw() {
	if(visited.insert(TYPE).second) {
	    Association::ref_uproot_impl(visited);
	    
	    Class::ref_uproot_impl(visited);
	    
	    REF::Context * context = ref_get_context();
	    
	    ASSERT(context);
	    
	    UML * model = known_cast<UML *>(context);
	    
	    model->internal_add_association_class(this);
	}
    }
    
    bool
    AssociationClass::ref_add_role_impl(set<string> & visited,
					const string & role_name,
					REF::Class * role,
					REF::Class * position) {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_add_role_impl(visited, role_name, role, position)) {
		return true;
	    }
	    
	    if(Class::ref_add_role_impl(visited, role_name, role, position)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_remove_role_impl(set<string> & visited,
					   const string & role_name,
					   REF::Class * role) {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_remove_role_impl(visited, role_name, role)) {
		return true;
	    }
	    
	    if(Class::ref_remove_role_impl(visited, role_name, role)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_get_role_impl(set<string> & visited,
					REF::Class * & role,
					const string & role_name) {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_get_role_impl(visited, role, role_name)) {
		return true;
	    }
	    
	    if(Class::ref_get_role_impl(visited, role, role_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_set_role_impl(set<string> & visited,
					const string & role_name,
					REF::Class * role) {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_set_role_impl(visited, role_name, role)) {
		return true;
	    }
	    
	    if(Class::ref_set_role_impl(visited, role_name, role)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_create_class_impl(set<string> & visited,
					    REF::Class * & role,
					    const string & role_name) const {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_create_class_impl(visited, role, role_name)) {
		return true;
	    }
	    
	    if(Class::ref_create_class_impl(visited, role, role_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_get_role_iterator_impl(set<string> & visited,
						 REF::Iterator * & iterator,
						 const string & role_name) {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_get_role_iterator_impl(visited, iterator, role_name)) {
		return true;
	    }
	    
	    if(Class::ref_get_role_iterator_impl(visited, iterator, role_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_get_attribute_impl(set<string> & visited,
					     const REF::Attribute * & attribute,
					     const string & attribute_name) const {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_get_attribute_impl(visited, attribute, attribute_name)) {
		return true;
	    }
	    
	    if(Class::ref_get_attribute_impl(visited, attribute, attribute_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_set_attribute_impl(set<string> & visited,
					     const string & attribute_name,
					     const REF::Attribute * attribute) {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_set_attribute_impl(visited, attribute_name, attribute)) {
		return true;
	    }
	    
	    if(Class::ref_set_attribute_impl(visited, attribute_name, attribute)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_get_attribute_set_impl(set<string> & visited,
						 const vector<const REF::Attribute *> * & attribute_set,
						 const string & attribute_name) const {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_get_attribute_set_impl(visited, attribute_set, attribute_name)) {
		return true;
	    }
	    
	    if(Class::ref_get_attribute_set_impl(visited, attribute_set, attribute_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_set_attribute_set_impl(set<string> & visited,
						 const string & attribute_name,
						 const vector<const REF::Attribute *> * attribute_set) {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_set_attribute_set_impl(visited, attribute_name, attribute_set)) {
		return true;
	    }
	    
	    if(Class::ref_set_attribute_set_impl(visited, attribute_name, attribute_set)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_create_attribute_impl(set<string> & visited,
						REF::Attribute * & attribute,
						const string & attribute_name) const {
	if(visited.insert(TYPE).second) {
	    if(Association::ref_create_attribute_impl(visited, attribute, attribute_name)) {
		return true;
	    }
	    
	    if(Class::ref_create_attribute_impl(visited, attribute, attribute_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    bool
    AssociationClass::ref_is_a_type_of_impl(set<string> & visited,
					    const string & class_name) const {
	if(visited.insert(TYPE).second) {
	    if(class_name == "AssociationClass") {
		return true;
	    }
	    
	    if(Association::ref_is_a_type_of_impl(visited, class_name)) {
		return true;
	    }
	    
	    if(Class::ref_is_a_type_of_impl(visited, class_name)) {
		return true;
	    }
	    
	    return false;
	}
	else {
	    return false;
	}
    }
    
    const string &
    AssociationClass::ref_get_type() const {
	return TYPE;
    }
    
    void
    AssociationClass::ref_delete_impl(set<string> & visited) {
	if(visited.insert(TYPE).second) {
	    Association::ref_delete_impl(visited);
	    Class::ref_delete_impl(visited);
	}
    }
    
} // namespace UML
