// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif // HAVE_CONFIG_H

#include "call_concurrency_kind.h"

#include "reflective/exceptions.h"

#include <sstream>
using namespace std;

namespace UML {
    
    const string CallConcurrencyKind::TYPE = "CallConcurrencyKind";
    
    const string CallConcurrencyKind::TABLE[] = {
	"sequential",
	"guarded",
	"concurrent",
    };
    
    const int CallConcurrencyKind::TABLE_SIZE = sizeof(TABLE) / sizeof(TABLE[0]);
    
    CallConcurrencyKind::CallConcurrencyKind() : REF::Attribute(), mIndex(0) {
    }
    
    CallConcurrencyKind::~CallConcurrencyKind() {
    }
    
    void
    CallConcurrencyKind::ref_set_value(const string & value) {
	istringstream ist(value);
	
	string literal;
	ist >> literal;
	
	for(int i = 0; i < TABLE_SIZE; ++i) {
	    if(TABLE[i] == literal) {
		mIndex = i;
		return;
	    }
	}
	
	throw REF::BadValue("CallConcurrencyKind: " + value);
    }
    
    void
    CallConcurrencyKind::ref_get_value(string & value) const {
	value += TABLE[mIndex];
    }
    
    const string &
    CallConcurrencyKind::ref_get_type() const {
	return TYPE;
    }
    
    const string &
    CallConcurrencyKind::get_value() const {
	return TABLE[mIndex];
    }
    
} // namespace UML
