// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_FOUNDATION_EXTENSION_MECHANISMS_STEREOTYPE_H
#define UML_FOUNDATION_EXTENSION_MECHANISMS_STEREOTYPE_H

#include "uml/foundation/core/generalizable_element.h"

#include <list>
using namespace std;

namespace UML {
    
    class Constraint;
    class ModelElement;
    class TagDefinition;
    
    class Stereotype : public GeneralizableElement {
    public:
	//
	// constructor/destructor
	//
	
	Stereotype();
	~Stereotype();
	
	//
	// access to roles and role containers
	//
	
	const list<ModelElement *> & get_extended_element() const { return mExtendedElement; }
	void set_extended_element(const list<ModelElement *> & extended_element);
	void add_extended_element(ModelElement * extended_element, int index = -1);
	void remove_extended_element(ModelElement * extended_element);
	
	void internal_add_extended_element(ModelElement * extended_element);
	void internal_remove_extended_element(ModelElement * extended_element);
	
	const list<Constraint *> & get_stereotype_constraint() const { return mStereotypeConstraint; }
	void set_stereotype_constraint(const list<Constraint *> & stereotype_constraint);
	void add_stereotype_constraint(Constraint * stereotype_constraint, int index = -1);
	void remove_stereotype_constraint(Constraint * stereotype_constraint);
	
	void internal_add_stereotype_constraint(Constraint * stereotype_constraint);
	void internal_remove_stereotype_constraint(Constraint * stereotype_constraint);
	
	const list<TagDefinition *> & get_defined_tag() const { return mDefinedTag; }
	void set_defined_tag(const list<TagDefinition *> & defined_tag);
	void add_defined_tag(TagDefinition * defined_tag, int index = -1);
	void remove_defined_tag(TagDefinition * defined_tag);
	
	void internal_add_defined_tag(TagDefinition * defined_tag);
	void internal_remove_defined_tag(TagDefinition * defined_tag);
	
	//
	// access to attributes
	//
	
	const string & ref_get_type() const;
	
    protected:
	//
	// reflective interface
	//
	
	void ref_set_context_impl(set<string> & visited, REF::Context * context);
	void ref_implant_impl(set<string> & visited) throw();
	void ref_uproot_impl(set<string> & visited) throw();
	
	//
	
	bool ref_is_a_type_of_impl(set<string> & visited,
				   const string & class_name) const;
	
	void ref_delete_impl(set<string> & visited);
	
	//
	
	bool ref_add_role_impl(set<string> & visited,
			       const string & role_name,
			       REF::Class * role,
			       REF::Class * position);
	
	bool ref_remove_role_impl(set<string> & visited,
				  const string & role_name,
				  REF::Class * role);
	
	bool ref_get_role_iterator_impl(set<string> & visited,
					REF::Iterator * & iterator,
					const string & role_name);
	
	bool ref_get_role_impl(set<string> & visited,
			       REF::Class * & role,
			       const string & role_name);
	
	bool ref_set_role_impl(set<string> & visited,
			       const string & role_name,
			       REF::Class * role);
	
	bool ref_create_class_impl(set<string> & visited,
				   REF::Class * & role,
				   const string & role_name) const;
	
	//
	
	bool ref_get_attribute_impl(set<string> & visited,
				    const REF::Attribute * & attribute,
				    const string & attribute_name) const;
	
	bool ref_set_attribute_impl(set<string> & visited,
				    const string & attribute_name,
				    const REF::Attribute * attribute);
	
	bool ref_get_attribute_set_impl(set<string> & visited,
					const vector<const REF::Attribute *> * & attribute_set,
					const string & attribute_name) const;
	
	bool ref_set_attribute_set_impl(set<string> & visited,
					const string & attribute_name,
					const vector<const REF::Attribute *> * attribute_set);
	
	bool ref_create_attribute_impl(set<string> & visited,
				       REF::Attribute * & attribute,
				       const string & attribute_name) const;
	
    private:
	//
	// copy constructor (copying is forbidden)
	//
	
	Stereotype(const Stereotype & stereotype);
	
	//
	// roles storage
	//
	
	list<ModelElement *> mExtendedElement;
	list<Constraint *> mStereotypeConstraint;
	list<TagDefinition *> mDefinedTag;
	
	//
	// our type
	//
	
	static const string TYPE;
    };
    
} // namespace UML

#endif // UML_FOUNDATION_EXTENSION_MECHANISMS_STEREOTYPE_H
