// generated by Dachshund V0.1.0
//
// Dachshund,
// Copyright (C) 2001 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UML_H
#define UML_H

#include "reflective/context.h"

#include <set>
using namespace std;

namespace UML {
    
    using namespace REF;
    
    class GeneralizableElement;
    class Constraint;
    class Classifier;
    class StructuralFeature;
    class BehavioralFeature;
    class Element;
    class Attribute;
    class Operation;
    class Method;
    class ModelElement;
    class Feature;
    class Namespace;
    class Parameter;
    class Interface;
    class DataType;
    class Node;
    class Comment;
    class Relationship;
    class Dependency;
    class Binding;
    class Abstraction;
    class Usage;
    class Permission;
    class Generalization;
    class Class;
    class AssociationClass;
    class Association;
    class AssociationEnd;
    class Stereotype;
    class TaggedValue;
    class TagDefinition;
    class Package;
    class Model;
    class Diagram;
    class GraphElement;
    class PresentationElement;
    class EdgeElement;
    class NodeElement;
    class ClassPresentation;
    class PackagePresentation;
    class CommentPresentation;
    class AssociationPresentation;
    class GeneralizationPresentation;
    class DependencyPresentation;
    
    class UML : public Context {
    public:
	UML();
	
	REF::Class * ref_create_class(const string & class_name);
	
	REF::Attribute * ref_create_attribute(const string & attribute_name);
	
	const set<GeneralizableElement *> & get_all_of_type_generalizable_element() {
	    return mAllOfTypeGeneralizableElement;
	}
	
	void internal_add_generalizable_element(GeneralizableElement * element);
	void internal_remove_generalizable_element(GeneralizableElement * element);
	
	const set<Constraint *> & get_all_of_type_constraint() {
	    return mAllOfTypeConstraint;
	}
	
	void internal_add_constraint(Constraint * element);
	void internal_remove_constraint(Constraint * element);
	
	const set<Classifier *> & get_all_of_type_classifier() {
	    return mAllOfTypeClassifier;
	}
	
	void internal_add_classifier(Classifier * element);
	void internal_remove_classifier(Classifier * element);
	
	const set<StructuralFeature *> & get_all_of_type_structural_feature() {
	    return mAllOfTypeStructuralFeature;
	}
	
	void internal_add_structural_feature(StructuralFeature * element);
	void internal_remove_structural_feature(StructuralFeature * element);
	
	const set<BehavioralFeature *> & get_all_of_type_behavioral_feature() {
	    return mAllOfTypeBehavioralFeature;
	}
	
	void internal_add_behavioral_feature(BehavioralFeature * element);
	void internal_remove_behavioral_feature(BehavioralFeature * element);
	
	const set<Element *> & get_all_of_type_element() {
	    return mAllOfTypeElement;
	}
	
	void internal_add_element(Element * element);
	void internal_remove_element(Element * element);
	
	const set<Attribute *> & get_all_of_type_attribute() {
	    return mAllOfTypeAttribute;
	}
	
	void internal_add_attribute(Attribute * element);
	void internal_remove_attribute(Attribute * element);
	
	const set<Operation *> & get_all_of_type_operation() {
	    return mAllOfTypeOperation;
	}
	
	void internal_add_operation(Operation * element);
	void internal_remove_operation(Operation * element);
	
	const set<Method *> & get_all_of_type_method() {
	    return mAllOfTypeMethod;
	}
	
	void internal_add_method(Method * element);
	void internal_remove_method(Method * element);
	
	const set<ModelElement *> & get_all_of_type_model_element() {
	    return mAllOfTypeModelElement;
	}
	
	void internal_add_model_element(ModelElement * element);
	void internal_remove_model_element(ModelElement * element);
	
	const set<Feature *> & get_all_of_type_feature() {
	    return mAllOfTypeFeature;
	}
	
	void internal_add_feature(Feature * element);
	void internal_remove_feature(Feature * element);
	
	const set<Namespace *> & get_all_of_type_namespace() {
	    return mAllOfTypeNamespace;
	}
	
	void internal_add_namespace(Namespace * element);
	void internal_remove_namespace(Namespace * element);
	
	const set<Parameter *> & get_all_of_type_parameter() {
	    return mAllOfTypeParameter;
	}
	
	void internal_add_parameter(Parameter * element);
	void internal_remove_parameter(Parameter * element);
	
	const set<Interface *> & get_all_of_type_interface() {
	    return mAllOfTypeInterface;
	}
	
	void internal_add_interface(Interface * element);
	void internal_remove_interface(Interface * element);
	
	const set<DataType *> & get_all_of_type_data_type() {
	    return mAllOfTypeDataType;
	}
	
	void internal_add_data_type(DataType * element);
	void internal_remove_data_type(DataType * element);
	
	const set<Node *> & get_all_of_type_node() {
	    return mAllOfTypeNode;
	}
	
	void internal_add_node(Node * element);
	void internal_remove_node(Node * element);
	
	const set<Comment *> & get_all_of_type_comment() {
	    return mAllOfTypeComment;
	}
	
	void internal_add_comment(Comment * element);
	void internal_remove_comment(Comment * element);
	
	const set<Relationship *> & get_all_of_type_relationship() {
	    return mAllOfTypeRelationship;
	}
	
	void internal_add_relationship(Relationship * element);
	void internal_remove_relationship(Relationship * element);
	
	const set<Dependency *> & get_all_of_type_dependency() {
	    return mAllOfTypeDependency;
	}
	
	void internal_add_dependency(Dependency * element);
	void internal_remove_dependency(Dependency * element);
	
	const set<Binding *> & get_all_of_type_binding() {
	    return mAllOfTypeBinding;
	}
	
	void internal_add_binding(Binding * element);
	void internal_remove_binding(Binding * element);
	
	const set<Abstraction *> & get_all_of_type_abstraction() {
	    return mAllOfTypeAbstraction;
	}
	
	void internal_add_abstraction(Abstraction * element);
	void internal_remove_abstraction(Abstraction * element);
	
	const set<Usage *> & get_all_of_type_usage() {
	    return mAllOfTypeUsage;
	}
	
	void internal_add_usage(Usage * element);
	void internal_remove_usage(Usage * element);
	
	const set<Permission *> & get_all_of_type_permission() {
	    return mAllOfTypePermission;
	}
	
	void internal_add_permission(Permission * element);
	void internal_remove_permission(Permission * element);
	
	const set<Generalization *> & get_all_of_type_generalization() {
	    return mAllOfTypeGeneralization;
	}
	
	void internal_add_generalization(Generalization * element);
	void internal_remove_generalization(Generalization * element);
	
	const set<Class *> & get_all_of_type_class() {
	    return mAllOfTypeClass;
	}
	
	void internal_add_class(Class * element);
	void internal_remove_class(Class * element);
	
	const set<AssociationClass *> & get_all_of_type_association_class() {
	    return mAllOfTypeAssociationClass;
	}
	
	void internal_add_association_class(AssociationClass * element);
	void internal_remove_association_class(AssociationClass * element);
	
	const set<Association *> & get_all_of_type_association() {
	    return mAllOfTypeAssociation;
	}
	
	void internal_add_association(Association * element);
	void internal_remove_association(Association * element);
	
	const set<AssociationEnd *> & get_all_of_type_association_end() {
	    return mAllOfTypeAssociationEnd;
	}
	
	void internal_add_association_end(AssociationEnd * element);
	void internal_remove_association_end(AssociationEnd * element);
	
	const set<Stereotype *> & get_all_of_type_stereotype() {
	    return mAllOfTypeStereotype;
	}
	
	void internal_add_stereotype(Stereotype * element);
	void internal_remove_stereotype(Stereotype * element);
	
	const set<TaggedValue *> & get_all_of_type_tagged_value() {
	    return mAllOfTypeTaggedValue;
	}
	
	void internal_add_tagged_value(TaggedValue * element);
	void internal_remove_tagged_value(TaggedValue * element);
	
	const set<TagDefinition *> & get_all_of_type_tag_definition() {
	    return mAllOfTypeTagDefinition;
	}
	
	void internal_add_tag_definition(TagDefinition * element);
	void internal_remove_tag_definition(TagDefinition * element);
	
	const set<Package *> & get_all_of_type_package() {
	    return mAllOfTypePackage;
	}
	
	void internal_add_package(Package * element);
	void internal_remove_package(Package * element);
	
	const set<Model *> & get_all_of_type_model() {
	    return mAllOfTypeModel;
	}
	
	void internal_add_model(Model * element);
	void internal_remove_model(Model * element);
	
	const set<Diagram *> & get_all_of_type_diagram() {
	    return mAllOfTypeDiagram;
	}
	
	void internal_add_diagram(Diagram * element);
	void internal_remove_diagram(Diagram * element);
	
	const set<GraphElement *> & get_all_of_type_graph_element() {
	    return mAllOfTypeGraphElement;
	}
	
	void internal_add_graph_element(GraphElement * element);
	void internal_remove_graph_element(GraphElement * element);
	
	const set<PresentationElement *> & get_all_of_type_presentation_element() {
	    return mAllOfTypePresentationElement;
	}
	
	void internal_add_presentation_element(PresentationElement * element);
	void internal_remove_presentation_element(PresentationElement * element);
	
	const set<EdgeElement *> & get_all_of_type_edge_element() {
	    return mAllOfTypeEdgeElement;
	}
	
	void internal_add_edge_element(EdgeElement * element);
	void internal_remove_edge_element(EdgeElement * element);
	
	const set<NodeElement *> & get_all_of_type_node_element() {
	    return mAllOfTypeNodeElement;
	}
	
	void internal_add_node_element(NodeElement * element);
	void internal_remove_node_element(NodeElement * element);
	
	const set<ClassPresentation *> & get_all_of_type_class_presentation() {
	    return mAllOfTypeClassPresentation;
	}
	
	void internal_add_class_presentation(ClassPresentation * element);
	void internal_remove_class_presentation(ClassPresentation * element);
	
	const set<PackagePresentation *> & get_all_of_type_package_presentation() {
	    return mAllOfTypePackagePresentation;
	}
	
	void internal_add_package_presentation(PackagePresentation * element);
	void internal_remove_package_presentation(PackagePresentation * element);
	
	const set<CommentPresentation *> & get_all_of_type_comment_presentation() {
	    return mAllOfTypeCommentPresentation;
	}
	
	void internal_add_comment_presentation(CommentPresentation * element);
	void internal_remove_comment_presentation(CommentPresentation * element);
	
	const set<AssociationPresentation *> & get_all_of_type_association_presentation() {
	    return mAllOfTypeAssociationPresentation;
	}
	
	void internal_add_association_presentation(AssociationPresentation * element);
	void internal_remove_association_presentation(AssociationPresentation * element);
	
	const set<GeneralizationPresentation *> & get_all_of_type_generalization_presentation() {
	    return mAllOfTypeGeneralizationPresentation;
	}
	
	void internal_add_generalization_presentation(GeneralizationPresentation * element);
	void internal_remove_generalization_presentation(GeneralizationPresentation * element);
	
	const set<DependencyPresentation *> & get_all_of_type_dependency_presentation() {
	    return mAllOfTypeDependencyPresentation;
	}
	
	void internal_add_dependency_presentation(DependencyPresentation * element);
	void internal_remove_dependency_presentation(DependencyPresentation * element);
	
	
    protected:
	~UML();
	
    private:
	set<GeneralizableElement *> mAllOfTypeGeneralizableElement;
	set<Constraint *> mAllOfTypeConstraint;
	set<Classifier *> mAllOfTypeClassifier;
	set<StructuralFeature *> mAllOfTypeStructuralFeature;
	set<BehavioralFeature *> mAllOfTypeBehavioralFeature;
	set<Element *> mAllOfTypeElement;
	set<Attribute *> mAllOfTypeAttribute;
	set<Operation *> mAllOfTypeOperation;
	set<Method *> mAllOfTypeMethod;
	set<ModelElement *> mAllOfTypeModelElement;
	set<Feature *> mAllOfTypeFeature;
	set<Namespace *> mAllOfTypeNamespace;
	set<Parameter *> mAllOfTypeParameter;
	set<Interface *> mAllOfTypeInterface;
	set<DataType *> mAllOfTypeDataType;
	set<Node *> mAllOfTypeNode;
	set<Comment *> mAllOfTypeComment;
	set<Relationship *> mAllOfTypeRelationship;
	set<Dependency *> mAllOfTypeDependency;
	set<Binding *> mAllOfTypeBinding;
	set<Abstraction *> mAllOfTypeAbstraction;
	set<Usage *> mAllOfTypeUsage;
	set<Permission *> mAllOfTypePermission;
	set<Generalization *> mAllOfTypeGeneralization;
	set<Class *> mAllOfTypeClass;
	set<AssociationClass *> mAllOfTypeAssociationClass;
	set<Association *> mAllOfTypeAssociation;
	set<AssociationEnd *> mAllOfTypeAssociationEnd;
	set<Stereotype *> mAllOfTypeStereotype;
	set<TaggedValue *> mAllOfTypeTaggedValue;
	set<TagDefinition *> mAllOfTypeTagDefinition;
	set<Package *> mAllOfTypePackage;
	set<Model *> mAllOfTypeModel;
	set<Diagram *> mAllOfTypeDiagram;
	set<GraphElement *> mAllOfTypeGraphElement;
	set<PresentationElement *> mAllOfTypePresentationElement;
	set<EdgeElement *> mAllOfTypeEdgeElement;
	set<NodeElement *> mAllOfTypeNodeElement;
	set<ClassPresentation *> mAllOfTypeClassPresentation;
	set<PackagePresentation *> mAllOfTypePackagePresentation;
	set<CommentPresentation *> mAllOfTypeCommentPresentation;
	set<AssociationPresentation *> mAllOfTypeAssociationPresentation;
	set<GeneralizationPresentation *> mAllOfTypeGeneralizationPresentation;
	set<DependencyPresentation *> mAllOfTypeDependencyPresentation;
    };
    
} // namespace UML

#endif // UML_H
