// Dachshund,
// Copyright (C) 2000 David Bryant
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef XML_PROPERTY_H
#define XML_PROPERTY_H

#include "foundation/object.h"

#include <string>
#include <iosfwd>
using namespace std;

namespace XML {

    class Property : public Object {
    public:
	Property();
	Property(const string & name, const string & value);
	~Property();

	const string & get_name() const { return mName; }
	void set_name(const string & name);

	const string & get_value() const { return mValue; }
	void set_value(const string & value);

    private:
	string mName;
	string mValue;
    };

    ostream & operator << (ostream & ost, const Property & property);

} // namespace XML

#endif // XML_PROPERTY_H
